package com.microservices.pms.productLibrary.mapper;

import com.microservices.pms.productLibrary.domain.PmsProductlibJyrjd;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (PmsProductlibJyrjd)表数据库访问层
 *
 * @author makejava
 * @since 2023-12-08 15:09:21
 */
public interface PmsProductlibJyrjdMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PmsProductlibJyrjd queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param pmsProductlibJyrjd 查询条件
     * @param pageable           分页对象
     * @return 对象列表
     */
    List<PmsProductlibJyrjd> queryAllByLimit(PmsProductlibJyrjd pmsProductlibJyrjd, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param pmsProductlibJyrjd 查询条件
     * @return 总行数
     */
    long count(PmsProductlibJyrjd pmsProductlibJyrjd);

    /**
     * 新增数据
     *
     * @param pmsProductlibJyrjd 实例对象
     * @return 影响行数
     */
    int insert(PmsProductlibJyrjd pmsProductlibJyrjd);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PmsProductlibJyrjd> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PmsProductlibJyrjd> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PmsProductlibJyrjd> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PmsProductlibJyrjd> entities);

    /**
     * 修改数据
     *
     * @param pmsProductlibJyrjd 实例对象
     * @return 影响行数
     */
    int update(PmsProductlibJyrjd pmsProductlibJyrjd);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    int deleteByPath(String path);

    PmsProductlibJyrjd queryByPath(String name);

    PmsProductlibJyrjd queryByPmsProductlibJyrjd(PmsProductlibJyrjd pmsProductlibJyrjd);
}

